今天和大家聊的问题叫做 搜索插入位置,我们先来看题面:
https://leetcode-cn.com/problems/search-insert-position/
Given a sorted array and a target value, return the index if the target is found. If not, return the index where it would be if it were inserted in order.
You may assume no duplicates in the array.
题意
给定一个排序数组和一个目标值,在数组中找到目标值,并返回其索引。如果目标值不存在于数组中,返回它将会被按顺序插入的位置。你可以假设数组中无重复元素。
样例
示例 1: 输入: [1,3,5,6], 5 输出: 2 示例 2: 输入: [1,3,5,6], 2 输出: 1 示例 3: 输入: [1,3,5,6], 7 输出: 4 示例 4: 输入: [1,3,5,6], 0 输出: 0
题解
这题应该算简单题吧,主要有两种解法:暴力解法和二分查找法 。
一种方法是直接遍历有序的数组,发现元素大于等于target,那么这个索引就是目标索引了。时间复杂度是O(n)
public int searchInsert(int[] nums, int target) { if (nums.length == 0) { return 0; } for (int i = 0; i < nums.length; i++) { if (nums[i] >= target) return i; } return nums.length; }
采用二分查找算法,定义和左右边界缩小查找范围。二分查找所需的时间复杂度为 O(logn)
class Solution { public int searchInsert(int[] nums, int target) { int n = nums.length; int left = 0, right = n - 1, ans = n; while (left <= right) { int mid = ((right - left) >> 1) + left; if (target <= nums[mid]) { ans = mid; right = mid - 1; } else { left = mid + 1; } } return ans; } }
好了,今天的文章就到这里,如果觉得有所收获,请顺手点个在看或者转发吧,你们的支持是我最大的动力。